{startovni cislo 30}
program Rodokmen;
uses Graph;

{ abstraktni datova struktura strom }
type uuOsoba = ^uOsoba; {ukazatel na ukazatel na osobu}
     uOsoba  = ^osoba;
     osoba   = record
                id       : string[10];
                jmeno    : string[32];
                prijmeni : string[32];
                pohlavi  : (muz, zena);
                narozeni : word;
                umrti    : word;
                matka    : string[10];
                otec     : string[10];
               end;

var gd, gm : integer;
    soubor : text;
    pocet  : word;
    osoby  : uuOsoba;{tohle bude dynamicke pole ukazatelu}

procedure error;
begin
WRITELN (' Chyba pri nacitani souboru:');
WRITELN (' Soubor zrejme neni v zadanem formatu, obsahuje chybne nebo neukoncene');
Writeln (' tagy, pripadne nezacina tagem <rodokmen> nebo neco podobneho.');
writeln (' Opravte chybu a zkuste to znovu.');
halt(1);
end;


function PocetOsob (var f : text): word;
var po : word;
    z7 : array [1..7] of char; {zasobnik na poslednich 7 nactenych znaku}
    i : integer;
begin
 po := 0;
 for i := 1 to 7 do z7[i] := chr(0);
 reset(f);
 while not eof(f) do
 begin
  for i := 1 to 7 do z7[i] := z7[i+1];
  read(f, z7[7]);
  z7[7] := upcase(z7[7]);
  if z7 = '<OSOBA>' then inc(po);
 end;
 close(f);
 PocetOsob := po;
end;

procedure NactiRodokmen(var f : text; p : uuOsoba);
var c : char;
    zas : string; {pomocny zasobnik znaku}
    rk : boolean; {jsme vubec mezi tagy rodokmen?}
    osoba : boolean; {jsme mezi tagy osoba?}
    tag : (mimo, tID, tJMENO, tPRIJMENI, tPOHLAVI, tNAROZENI, tUMRTI, tMATKA, tOTEC);
    {mezi kterymi tagy se nachazime}
    Code : integer; {pro fci Val}
begin
 rk := false; osoba := false; tag := mimo;
 Reset(f);
 while not eof(f) do
 begin
  read(f,c);
  c := upcase(c);
  case c of
   '<': begin
         if tag <> mimo then
          case tag of
           tID: p^^.id := zas;
           tJMENO: p^^.jmeno := zas;
           tPRIJMENI: p^^.prijmeni := zas;
           tPOHLAVI: if zas = 'M' then p^^.pohlavi := muz else
                     if zas = 'Z' then p^^.pohlavi := zena else
                     error;
           tNAROZENI: begin
                       Val(zas, p^^.narozeni, Code);
                       if Code <> 0 then error;
                      end;
           tUMRTI: begin
                    Val(zas, p^^.umrti, Code);
                    if Code <> 0 then error;
                   end;
           tMATKA: p^^.matka := zas;
           tOTEC:  p^^.otec := zas;
          end;
         zas := '';
        end;
   '>': begin
         if zas = 'RODOKMEN' then if not rk then rk := true else error;
         if zas = 'OSOBA'    then
         begin
          if not rk then error;
          new (p^);
          osoba := true;
          with p^^ do
          begin
           id := '';
           jmeno := '';
           prijmeni := '';
           pohlavi := muz;
           narozeni := 0;
           umrti := 0;
           matka := '';
           otec := '';
          end;
         end;
         if zas = 'ID'       then if osoba and (tag = mimo) then tag := tID else error;
         if zas = 'JMENO'    then if osoba and (tag = mimo) then tag := tJMENO else error;
         if zas = 'PRIJMENI' then if osoba and (tag = mimo) then tag := tPRIJMENI else error;
         if zas = 'POHLAVI'  then if osoba and (tag = mimo) then tag := tPOHLAVI else error;
         if zas = 'NAROZENI' then if osoba and (tag = mimo) then tag := tNAROZENI else error;
         if zas = 'UMRTI'    then if osoba and (tag = mimo) then tag := tUMRTI else error;
         if zas = 'MATKA'    then if osoba and (tag = mimo) then tag := tMATKA else error;
         if zas = 'OTEC'     then if osoba and (tag = mimo) then tag := tOTEC else error;
         if zas = '/RODOKMEN' then if rk then rk := false else error;
         if zas = '/OSOBA' then
         begin
          if not osoba then error;
          inc(p);
          osoba := false;
         end;
         if zas = '/ID' then if tag = tID then tag := mimo else error;
         if zas = '/JMENO' then if tag = tJMENO then tag := mimo else error;
         if zas = '/PRIJMENI' then if tag = tPRIJMENI then tag := mimo else error;
         if zas = '/POHLAVI' then if tag = tPOHLAVI then tag := mimo else error;
         if zas = '/NAROZENI' then if tag = tNAROZENI then tag := mimo else error;
         if zas = '/UMRTI' then if tag = tUMRTI then tag := mimo else error;
         if zas = '/MATKA' then if tag = tMATKA then tag := mimo else error;
         if zas = '/OTEC' then if tag = tOTEC then tag := mimo else error;
        zas := '';
        end;
   else zas := zas + c;
  end;
 end;
 if (rk = true) or (osoba = true) or (tag <> mimo) then error;
end;

function NajdiId (id : string) : uOsoba; {Najdi osobu s danym id}
var i : integer; p : uuosoba;
begin
 NajdiId := nil;
 p := osoby;
 for i := 1 to pocet do
 begin
  if p^^.id = id then begin NajdiId := p^; exit; end;
  inc(p);
 end;
end;



procedure VypisRodokmen;
var i : integer; p : uuosoba; os : uOsoba;
begin
 p := osoby;
 for i := 1 to pocet do
 begin
  write (p^^.id, ':', p^^.jmeno, ' ', p^^.prijmeni);
  if p^^.pohlavi = muz then writeln (' (muz)') else writeln (' (zena)');
  if p^^.narozeni > 0 then writeln ('Rok narozeni: ', p^^.narozeni);
  if p^^.umrti > 0 then writeln ('Rok umrti: ', p^^.umrti);
  os := najdiId(p^^.matka);
  if os <> nil then writeln ('Matka: ', os^.jmeno, ' ', os^.prijmeni);
  os := najdiId(p^^.otec);
  if os <> nil then writeln ('Otec: ', os^.jmeno, ' ', os^.prijmeni);

  readln;
  inc(p);
 end;
end;


begin
 assign(soubor, 'I:\zadani\kenedy.xml');
 {$I-}
 reset(soubor); close(soubor);
 {$I+}
 if IOResult <> 0 then
 begin
  Writeln ('Soubor neexistuje!');
  halt(1);
 end;
 pocet := PocetOsob(soubor);
 GetMem (osoby, sizeof(uOsoba)*pocet); {zde je vytvoreno dyn. pole ukazatelu}

 NactiRodokmen (soubor, osoby);
 VypisRodokmen;
 gd := detect;
 initgraph(gd, gm, '');

 closegraph;
 FreeMem (osoby, sizeof(uOsoba)*pocet); {no a tady je dyn. pol. uk. zruseno}
 readln;
end.

{
poznamky:
ID je citlive na velikost pismen ("case-sensitive"), tzn. ze je rozdil mezi
ID, Id, iD, id

PROC DYNAMICKE POLE UKAZATELU?
 - aby mohl byt temer libovolny pocet osob a aby se statickou deklaraci pole
   ukazatelu zbytecne nezabirala pamet
}